//////////////////////////////////////////////////////////////////////////
//   FAMICOM   PPJoy
//  GROUPBOX ,    DrawEdge
//       
//   Caption,   
//     -   
// 31-08-2017, 06:08:17
//////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "resource.h"
#include "PPJIoctl.h"

//  
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
ATOM RegMyWindowClass(HINSTANCE, LPCTSTR);
DWORD SendJKey(int, int);  

#define ID_MYBUTTONL 1    /*       */
#define ID_MYBUTTONR 2    /*       */
#define ID_MYBUTTONU 3    /*       */
#define ID_MYBUTTOND 4    /*       */
#define ID_MYBUTTONS 5    /*       */
#define ID_MYBUTTONG 6    /*       */
#define ID_MYBUTTONB 7    /*       */
#define ID_MYBUTTONA 8    /*       */
#define ID_MYBUTTONT 9    /*       */
#define ID_MYBUTTONV 10   /*       */

#define NUM_ANALOG  8     /* Number of analog values which we will provide */
#define NUM_DIGITAL 16    /* Number of digital values which we will provide */

//------------------------------------------------------------------------
#pragma pack(push,1)    /* All fields in structure must be byte aligned. */
typedef struct
{
 unsigned long  Signature;        /* Signature to identify packet to PPJoy IOCTL */
 char      NumAnalog;             /* Num of analog values we pass */
 long      Analog[NUM_ANALOG];    /* Analog values */
 char      NumDigital;            /* Num of digital values we pass */
 char      Digital[NUM_DIGITAL];  /* Digital values */
}  JOYSTICK_STATE;
#pragma pack(pop)

 HANDLE        hnIOFile;
 char         ch;
 JOYSTICK_STATE    JoyState;
 DWORD        RetSize;
 DWORD        rc;
 long        *Analog;
 char        *Digital;
 char        *DevName;
//------------------------------------------------------------------------

HICON hIcon;
HMENU HMenu;
HMENU hmnu;
HFONT hFont1 = NULL;
HFONT hFont2 = NULL;
HFONT hFont3 = NULL;
HFONT hFont4 = NULL;
HCURSOR hOldCursor, hNewCursor, hGetCursor;
HWND hwButton1, hwButton2, hwButton3, hwButton4, hwButton5;
HWND hwButton6, hwButton7, hwButton8, hwButton9, hwButton10;
HWND hGrpBox, xStatTxt, hFocusId;
BOOL GrpFlg=false;
BOOL Hidden=false;
UINT timer;  
HDC hdc;
DWORD retVal,oldVal;
PAINTSTRUCT ps;
HINSTANCE hInstan;

POINT pt;
RECT bRect,oRect;   
CHAR mes[255];                  //---   ---
CHAR mesg[255];                 //---   ---

//////////////////////////////////////////////////////////////////////////
//    WinMain
int APIENTRY WinMain(HINSTANCE hInstance,
             HINSTANCE         hPrevInstance,
             LPSTR             lpCmdLine,
             int               nCmdShow)
{
    hInstan = hInstance;

  //   
  LPCTSTR lpzClass = TEXT("GamePadClass");
              hNewCursor = LoadCursor (hInstan, MAKEINTRESOURCE(114));
          //  hNewCursor = LoadCursor (NULL, IDC_WAIT);
         if (!hNewCursor) MessageBox (NULL, "Error LoadCursor1 !", "  Attention!", MB_ICONSTOP | MB_OK );
              hGetCursor = LoadCursor (hInstan, MAKEINTRESOURCE(113));
         if (!hGetCursor) MessageBox (NULL, "Error LoadCursor2 !", "  Attention!", MB_ICONSTOP | MB_OK );

  //  
              hIcon = LoadIcon(hInstance,MAKEINTRESOURCE(102));
  //      (Ex4_Icon ICON "myicon.ico"),  ,
  //    ,   windows.h: MAKEINTRESOURCE(102)
         if (!hIcon) MessageBox (NULL, "Error LoadIcon!", "  Attention!", MB_ICONSTOP | MB_OK );

  //  
  if(!RegMyWindowClass(hInstance, lpzClass)){
     MessageBox (NULL, "Error Register WindowClass!", "  Attention!", MB_ICONSTOP | MB_OK );
    return 1;
    }
  //    
  RECT screen_rect;
  GetWindowRect(GetDesktopWindow(),&screen_rect); //  
  int x = screen_rect.right / 4 - 150;
  int y = screen_rect.bottom / 3 * 2 - 75;

  //    hWnd
  HWND hWnd = CreateWindow(lpzClass, TEXT("GamePad"),
    WS_OVERLAPPEDWINDOW | WS_VISIBLE, x, y, 340, 144, NULL, NULL,
    hInstance, NULL);

  //    ,    0
  if(!hWnd){
     MessageBox (NULL, "Error Create Window!", "  Attention!", MB_ICONSTOP | MB_OK );
     return 2;
    }
    ShowWindow (hWnd, nCmdShow);
    UpdateWindow (hWnd);

  //   
    MSG msg = {0};  //  
  int iGetOk = 0;   //  
  while ((iGetOk = GetMessage(&msg, NULL, 0, 0 )) != 0) //  
  {
  if(iGetOk == -1){
     MessageBox (NULL, "Error GetMessage!", "  Attention!", MB_ICONSTOP | MB_OK );
     return 3;  //  GetMessage   - 
    }
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;  //    
}

//////////////////////////////////////////////////////////////////////////
//    
ATOM RegMyWindowClass(HINSTANCE hInst, LPCTSTR lpzClassName)
{
  WNDCLASS wcWindowClass = {0};
  //  -  
  wcWindowClass.lpfnWndProc = (WNDPROC)WndProc;
  //  
  wcWindowClass.style = CS_HREDRAW|CS_VREDRAW;
  //   
  wcWindowClass.hInstance = hInst;
  //  
   wcWindowClass.hIcon = hIcon; //
  //  
  wcWindowClass.lpszMenuName = NULL;
 //  
  wcWindowClass.lpszClassName = lpzClassName;
  //  
  wcWindowClass.hCursor = LoadCursor(NULL, IDC_ARROW);
  //   
  wcWindowClass.hbrBackground = (HBRUSH)COLOR_APPWORKSPACE;
  return RegisterClass(&wcWindowClass); //  
}

//////////////////////////////////////////////////////////////////////////
//   
//////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//========     ================(HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE)
switch (message)
  {
  case WM_CREATE:
   //---         WS_VISIBLE
   //---       : ShowWindow(hControl, SW_SHOW);

   hFont1 =  CreateFont(28, 0, 0, 0, 0, 0, 0, 0, SYMBOL_CHARSET, 0, 0, 0, 0, "Marlett");
   hFont2 =  CreateFont(14, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, 0, "MS San Serif");
   hFont3 =  CreateFont(20, 0, 0, 0, 770, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, 0, "Verdana");
   hFont4 =  CreateFont(14, 0, 0, 0, 570, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, 0, "MS San Serif");

/*    hGrpBox = CreateWindow("button","",WS_CHILD|BS_GROUPBOX|WS_GROUP,
    1, 2, 328, 108,hWnd,NULL,NULL,NULL);
    PostMessage(hGrpBox, WM_SETFONT, (UINT)hFont2, 1); */

  hGrpBox = CreateWindowEx(0,"STATIC"," Famicom Joystic",WS_CHILD | WS_VISIBLE,
           7, 4, 108, 15,hWnd,NULL,
           (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),NULL);
    PostMessage(hGrpBox, WM_SETFONT, (UINT)hFont4, 1);

   /*        */
  hwButton1 = CreateWindow("button","3",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    8, 46, 48, 26,hWnd,(HMENU)ID_MYBUTTONL,NULL,NULL);
   /*  WS_CHILD ,        
          ,
          
       WM_COMMAND */
  hwButton2 = CreateWindow("button","4",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    60, 46, 50, 26,hWnd,(HMENU)ID_MYBUTTONR,NULL,NULL);
  hwButton3 = CreateWindow("button","5",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    34, 18, 44, 24,hWnd,(HMENU)ID_MYBUTTONU,NULL,NULL);
  hwButton4 = CreateWindow("button","6",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    34, 76, 44, 25,hWnd,(HMENU)ID_MYBUTTOND,NULL,NULL);

   PostMessage(hwButton1, WM_SETFONT, (UINT)hFont1, 1);
   PostMessage(hwButton2, WM_SETFONT, (UINT)hFont1, 1);
   PostMessage(hwButton3, WM_SETFONT, (UINT)hFont1, 1);
   PostMessage(hwButton4, WM_SETFONT, (UINT)hFont1, 1);

  hwButton5 = CreateWindow("button","Select",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    104, 76, 50, 26,hWnd,(HMENU)ID_MYBUTTONS,NULL,NULL);
  hwButton6 = CreateWindow("button","Start",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    158, 76, 56, 26,hWnd,(HMENU)ID_MYBUTTONG,NULL,NULL);
  hwButton7 = CreateWindow("button","B",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    226, 76, 32, 26,hWnd,(HMENU)ID_MYBUTTONB,NULL,NULL);
  hwButton8 = CreateWindow("button","A",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    262, 76, 32, 26,hWnd,(HMENU)ID_MYBUTTONA,NULL,NULL);
  hwButton9 = CreateWindow("button","Turbo B",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    202, 44, 56, 25,hWnd,(HMENU)ID_MYBUTTONT,NULL,NULL);
  hwButton10 = CreateWindow("button","Turbo A",WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE,
    262, 44, 59, 25,hWnd,(HMENU)ID_MYBUTTONV,NULL,NULL);
 //---    ------------------------------------------
   PostMessage(hwButton5, WM_SETFONT, (UINT)hFont2, 2);
   PostMessage(hwButton6, WM_SETFONT, (UINT)hFont2, 1);
   PostMessage(hwButton9, WM_SETFONT, (UINT)hFont2, 1);
   PostMessage(hwButton10, WM_SETFONT, (UINT)hFont2, 1);

 // xStatTxt = CreateWindowEx(0,"STATIC","TURBO",WS_CHILD|WS_VISIBLE,...)
 // In Microsoft Windows, a static control is an object created using the STATIC class.
 // Here is an example:
  xStatTxt = CreateWindowEx(0,"STATIC","TURBO",WS_CHILD | WS_VISIBLE,
           228, 20, 65, 20,hWnd,NULL,
           (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),NULL);
   PostMessage(xStatTxt, WM_SETFONT, (UINT)hFont3, 1);
   PostMessage(hwButton7, WM_SETFONT, (UINT)hFont3, 1);
   PostMessage(hwButton8, WM_SETFONT, (UINT)hFont3, 1);

   //------------    --------------
            HMenu = GetSystemMenu(hWnd, FALSE);
         if(HMenu != NULL) RemoveMenu(HMenu, 4, MF_BYPOSITION);
            HMenu = GetSystemMenu(hWnd, FALSE);
         if(HMenu != NULL) DeleteMenu(HMenu, SC_SIZE, NULL);
            retVal = GetWindowLong(hWnd, GWL_STYLE);
         if(retVal != NULL) SetWindowLong(hWnd, GWL_STYLE, retVal & ~WS_MAXIMIZEBOX);
            HMenu = NULL;
//---------  . ---------
    timer = SetTimer(hWnd, 1, 100, NULL);
//       if(timer == NULL) MessageBox (NULL, "Error Timer", "  Attention!", MB_OK );
   return 0; //--- END WM_CREATE

  case WM_SHOWWINDOW:
//   ShowWindow(),   
     GrpFlg=true;
  return 0;

  case WM_TIMER:
          if(GrpFlg){
       //     SetWindowText(hGrpBox, "Famicom Joystic"); 
       //     ShowWindow(hGrpBox, SW_SHOW);
       //     drawGbox(hWnd);
            GrpFlg=false;
            KillTimer(hWnd,timer);

            DevName= "\\\\.\\PPJoyIOCTL1";
      // int main (int argc, char **argv) //-    
      //   if(argc==2) DevName= argv[1];  //-    -   ...

      /* Open a handle to the control device for the first virtual joystick. */
      /* Virtual joystick devices are names PPJoyIOCTL1 to PPJoyIOCTL16. */
            hnIOFile=CreateFile(DevName,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);

      /* Make sure we could open the device! */
        if (hnIOFile == INVALID_HANDLE_VALUE) //---  winbase.h - (HANDLE)-1  
           {
            // printf ("CreateFile failed with error code %d trying to open %s device\n",GetLastError(),DevName);
            // return 1;
            MessageBox (hWnd, "Error: CreateFile failed!", "  Attention!", MB_ICONSTOP | MB_OK );
            PostMessage(hWnd, WM_CLOSE, NULL, NULL);  // WM_CLOSE or WM_DESTROY
           }
            else
           {
             /* Initialise the IOCTL data structure */
             JoyState.Signature = JOYSTICK_STATE_V1;
             JoyState.NumAnalog = NUM_ANALOG;       /* Number of analog values */
             Analog = JoyState.Analog;              /* Keep a pointer to the analog array for easy updating */
             JoyState.NumDigital = NUM_DIGITAL;     /* Number of digital values */
             Digital = JoyState.Digital;            /* Digital array */
             SetWindowText(hWnd, "GamePad - PPJoy"); 
           }

            SetFocus(hwButton6);
           }
  return 0; //--- END WM_TIMER ;

  case WM_NCMOUSEMOVE:  //---        ---
              if((wParam==HTBOTTOM)||(wParam==HTBOTTOMLEFT)||(wParam==HTBOTTOMRIGHT)||(wParam==HTLEFT)||(wParam==HTRIGHT)||(wParam==HTTOP)||(wParam==HTTOPLEFT)||(wParam==HTTOPRIGHT)){
                  hOldCursor = SetCursor (hNewCursor); // IDC_WAIT, IDC_ARROW
                  ShowCursor (TRUE); //---  hOldCursor     ---
                }                    //---       ---
  break; //---    switch (message) -  break;    
         //--- return DefWindowProc(hWnd, message, wParam, lParam);   
         //---    return 0; -     message 

  case WM_NCLBUTTONDOWN:  //---        ---
              if((wParam==HTBOTTOM)||(wParam==HTBOTTOMLEFT)||(wParam==HTBOTTOMRIGHT)||(wParam==HTLEFT)||(wParam==HTRIGHT)||(wParam==HTTOP)||(wParam==HTTOPLEFT)||(wParam==HTTOPRIGHT)){
                  hOldCursor = SetCursor (hGetCursor); // IDC_WAIT, IDC_ARROW
                  ShowCursor (TRUE);
                  SendMessage(hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0);
                 }
  break;

  case WM_PARENTNOTIFY:
   if((LOWORD(wParam)==WM_LBUTTONDOWN)) 
     {
//  lParam   ,        X, 
//        Y       .
      int Id = 0;
      int dX = LOWORD(lParam);
      int dY = HIWORD(lParam);
        pt.x = dX;
        pt.y = dY;
    hFocusId = ChildWindowFromPoint(hWnd, pt);
// ChildWindowFromPoint ,    ,   , 
//    (    ). 

/*
//---   ChildWindowFromPoint()  hFocusId = GetFocus(); 
      sprintf(mesg, "%p", hFocusId); 
      strcpy(mes, "> W=");
      strcat(mes, mesg);

The following works:
   POINT P;
   HWND Handle;

   GetCursorPos(&P);
   Handle=WindowFromPoint(P);
Point: pp TPoint ( p p).
p ; 0 -      .

      sprintf(mesg, "%d", dX); 
      strcpy(mes, "GamePad: X = ");
      strcat(mes, mesg);
      strcat(mes, ", Y = ");
      sprintf(mesg, "%d", dY); 
      strcat(mes, mesg);


// GetFocus,    ,     , 
//        
// IntPtr focusedHandle = GetFocus(); 

// HWND	- A handle to a window.This type is declared in WinDef.h as follows:
// typedef HANDLE HWND; if(HWND1 == HWND2) -   , switch(HWND) -  
//    INT	A 32-bit signed integer. The range is -2147483648 through 2147483647 decimal.

      hFocusId = GetFocus(); //-   HWND      :-(
 
      sprintf(mesg, "%p", hFocusId); //- %p prints the pointer.
      strcat(mes, ",G=");
      strcat(mes, mesg);
//    itoa(cyScr, mesg, 10); //-    ... ;-)
       SetWindowText(hWnd, "GamePad: PARENTNOTIFY !"); 
*/
            if(hFocusId == hwButton1){
                // SetWindowText(hWnd, "They are equal!"); 
                  Id = 1;
             }
             else if(hFocusId == hwButton2){
                  Id = 2;
             }
             else if(hFocusId == hwButton3){
                  Id = 3;
             }
             else if(hFocusId == hwButton4){
                  Id = 4;
             }
             else if(hFocusId == hwButton5){
                  Id = 5;
             }
             else if(hFocusId == hwButton6){
                  Id = 6;
             }
             else if(hFocusId == hwButton7){
                  Id = 7;
             }
             else if(hFocusId == hwButton8){
                  Id = 8;
             }
             else if(hFocusId == hwButton9){
                  Id = 9;
             }
             else if(hFocusId == hwButton10){
                  Id = 10;
             }
      if(Id>0)
        {
       if(SendJKey(Id,1) != 0)
         {
          SetWindowText(hWnd, "GamePad: IOCTL Error !"); 
         }
        }
     }
  break;

  case WM_RBUTTONUP:
  //    -      
  //  MessageBox(hWnd, TEXT(" !"), TEXT(""), 0);
  //  SendMessage(hwButton10, WM_SHOWWINDOW, NULL, NULL);
  //  SetWindowText(hGrpBox, "Dendy Joystic"); 
  //  ShowWindow(hGrpBox, SW_SHOW);
  //  ShowWindow(hGrpBox, SW_SHOWNOACTIVATE);
    if(Hidden)
      {
      if(oldVal != NULL){
         SetWindowLong(hWnd, GWL_STYLE, oldVal);
         oldVal=0;
         Hidden=false;
     //  SetWindowText(hWnd, "GamePad"); 
         GetWindowRect(hWnd, &bRect); //---    
         MoveWindow(hWnd,bRect.left,bRect.top,oRect.right-oRect.left,oRect.bottom-oRect.top,1);
         ShowWindow(hWnd, SW_SHOW);       
         }
      }
       else
      { //---  Caption
         GetWindowRect(hWnd, &oRect); //---    
         GetClientRect(hWnd, &bRect); //---    
         oldVal = GetWindowLong(hWnd, GWL_STYLE);
      if(oldVal != NULL){ 
      // SetWindowText(hWnd, "GamePad HIDDEN!"); 
         SetWindowLong(hWnd, GWL_STYLE, oldVal & ~WS_DLGFRAME);
         int wX = oRect.right - oRect.left; 
         int wY = oRect.bottom - oRect.top;
         int cX = bRect.right - bRect.left; 
         int cY = bRect.bottom - bRect.top;
 //      (wX - cX)/2 -  
 //       wY - 3*(wX - cX)/2 -  Caption
         MoveWindow(hWnd,oRect.left,oRect.top,wX,wY+3-3*(wX - cX)/2,1);
         ShowWindow(hWnd, SW_SHOW);
         Hidden=true; // retVal
         }
      } 
 break;

 /*
 case WM_MOUSEMOVE:
  // wParam      (Left, Right, Ctrl, Alt  ..).
  // lParam      :
  //  xPos = GET_X_LPARAM(lParam);
  //  yPos = GET_Y_LPARAM(lParam); 
      sprintf(mesg, "%d", lParam); //- %p prints the pointer.
      strcpy(mes, "GamePad: ");
//    itoa(cyScr, mesg, 10);
      strcat(mes, mesg);
      SetWindowText(hWnd, mes); 
  break;

 case WM_SETFOCUS:
      SetWindowText(hWnd, "GamePad: Set Focus"); 
   // WM_SETFOCUS message is sent to a window after it has gained the keyboard focus.
 break;


  case WM_LBUTTONDOWN:
  //    -     -  
     SetWindowText(hWnd, "GamePad - LEFT Down!"); 
  break;

  case WM_LBUTTONUP:
  //    -     -  
     SetWindowText(hWnd, "GamePad - LEFT Up!"); 
  break; */

  case WM_COMMAND:
   /*   ? && (LOWORD(wParam)==ID_MYBUTTONL))*/
   /*    BN_PUSHED  BN_UNPUSHED   MSDN :
      Win32-based applications should use the BS_OWNERDRAW button style 
      and the DRAWITEMSTRUCT structure for this task.
          BS_OWNERDRAW   WM_DRAWITEM.*/
   //    wParam     (IDB_BUTTON).
   //        : BN_CLICKED
   // MessageBox(hWnd,"You pressed button 'LEFT'!","MessageBox",MB_OK|MB_ICONWARNING);
   // ShowWindow(hGrpBox, SW_HIDE);
   if(HIWORD(wParam)==BN_CLICKED)
     {
        DWORD rId = 0; 
         WORD Idb = LOWORD(wParam);
      switch (Idb)
             {
              case ID_MYBUTTONL: 
                  rId = SendJKey(ID_MYBUTTONL,0); 
              break;

              case ID_MYBUTTONR:
                  rId = SendJKey(ID_MYBUTTONR,0); 
              break;

              case ID_MYBUTTONU:
                  rId = SendJKey(ID_MYBUTTONU,0); 
              break;

              case ID_MYBUTTOND: 
                  rId = SendJKey(ID_MYBUTTOND,0); 
              break;

              case ID_MYBUTTONS: 
                  rId = SendJKey(ID_MYBUTTONS,0); 
              break;

              case ID_MYBUTTONG: 
                  rId = SendJKey(ID_MYBUTTONG,0); 
              break;

              case ID_MYBUTTONB:
                  rId = SendJKey(ID_MYBUTTONB,0); 
              break;

              case ID_MYBUTTONA: 
                  rId = SendJKey(ID_MYBUTTONA,0); 
              break;

              case ID_MYBUTTONT: 
                  rId = SendJKey(ID_MYBUTTONT,0); 
              break;

              case ID_MYBUTTONV: 
                  rId = SendJKey(ID_MYBUTTONV,0); 
              break;
             }
 
      if(rId != 0){
         SetWindowText(hWnd, "GamePad: IOCTL Error !"); 
      if (rc==2)
         {
          // printf ("Underlying joystick device deleted. Exiting read loop\n");
            MessageBox (hWnd, "Underlying joystick device deleted!", "  Attention!", MB_ICONSTOP | MB_OK );
         }
         // printf ("DeviceIoControl error %d\n",rc);
            MessageBox (hWnd, "DeviceIoControl error!", "  Attention!", MB_ICONSTOP | MB_OK );
        }
     }
  return 0; //--- END WM_COMMAND ;

/*
  case WM_SIZE:
//               
//              SendMessage(hWndC, 5, 0, WindowWidth);
//              MessageBox (NULL, "WM_SIZE Message!", "  Attention!", MB_OK );
  return 0;
*/

  //      , Windows   WM_PAINT, 
  //    ,     . 
  // Windows   WM_PAINT       
  //    ,        .
  case WM_PAINT: //----------   .
            //   if(!bPnt){ //----------    
  //   BeginPaint  EndPaint       WM_PAINT. 
                 hdc = BeginPaint(hWnd, &ps); //   
                    GetClientRect(hWnd,&bRect);
                       bRect.left = 1;
                       bRect.top = 2;
                       bRect.right = bRect.right - 1;
                       bRect.bottom = bRect.bottom - 1;
                   DrawEdge(hdc, &bRect, BDR_RAISEDOUTER | BDR_SUNKENINNER, BF_RECT);
                 EndPaint (hWnd, &ps); //   
            //     }        //----------    
 return 0;


  case WM_DESTROY:
        CloseHandle(hnIOFile);
    if (oldVal != NULL) SetWindowLong(hWnd, GWL_STYLE, oldVal);
    if (hFont1) DeleteObject(hFont1);
    if (hFont2) DeleteObject(hFont2);
    if (hFont3) DeleteObject(hFont3);
    if (hFont4) DeleteObject(hFont4);
    PostQuitMessage(0);  //   
  return 0;

  default:
    //        Windows
    return DefWindowProc(hWnd, message, wParam, lParam);
  } //        Windows
 return DefWindowProc(hWnd, message, wParam, lParam); //--- END switch (message)
}
//------------------------------------------------------------------------------

DWORD SendJKey(int numButton, int btAction)
{
 /* On each iteration clear position buffer: Analog in centre, buttons not pressed */
 int  i;
  for(i=0; i < 8; i++) 
     {
      Analog[i]=(PPJOY_AXIS_MIN+PPJOY_AXIS_MAX)/2;
     }

//    memset (Digital,0,sizeof(JoyState.Digital));
  for(i=0; i < 16; i++) 
     {
      switch (i)
      {
       case 0:  Digital[0]= 0;  break;
       case 1:  Digital[1]= 0;  break;
       case 2:  Digital[2]= 0;  break;
       case 3:  Digital[3]= 0;  break;
       case 4:  Digital[4]= 0;  break;
       case 5:  Digital[5]= 0;  break;
       case 6:  Digital[6]= 0;  break;
       case 7:  Digital[7]= 0;  break;
       case 8:  Digital[8]= 0;  break;
       case 9:  Digital[9]= 0;  break;
       case 10:  Digital[10]= 0;  break;
       case 11:  Digital[11]= 0;  break;
       case 12:  Digital[12]= 0;  break;
       case 13:  Digital[13]= 0;  break;
       case 14:  Digital[14]= 0;  break;
       case 15:  Digital[15]= 0;  break;
      }
     } //---     0-  - " "
// MessageBox (NULL, "Hey! Button pressed!", "  Attention!", MB_ICONEXCLAMATION | MB_OK ); // Test

/* */
   if(btAction == 1) //---    -   '1'
     {
    if((numButton>0)&&(ch<11)) 
      {
       Digital[numButton-1] = 1; 
      } //---       :"  "
     } //---      1-  - ""

     rc = 0;
  /* Send request to PPJoy for processing. */
  /* Currently there is no Return Code from PPJoy, this may be added at a */
  /* later stage. So we pass a 0 byte output buffer. 
         -  :  winioctl.h  
     DeviceIoControl(...)   PPORTJOY!!! */
  if (!DeviceIoControl(hnIOFile,
       IOCTL_PPORTJOY_SET_STATE,
                      &JoyState,
               sizeof(JoyState),
                         NULL,0,
                       &RetSize,
                         NULL))
     {//    , DeviceIoControl  . 
      rc = GetLastError();
     }
  return rc;
}

/*
void drawGbox(HWND hWin){
              GetClientRect(hWin,&bRect);
              bRect.left = 1;
              bRect.top = 2;
              bRect.right = bRect.right - 1;
              bRect.bottom = bRect.bottom - 1;
              hdc = GetDC(hWin);
              DrawEdge(hdc, &bRect, BDR_RAISEDOUTER | BDR_SUNKENINNER, BF_RECT);
              ReleaseDC(hWin, hdc); 
}

*/



